Index: tools/test/script_tests/oopsScriptTest.pm
===================================================================
--- tools/test/script_tests/oopsScriptTest.pm	(revision 1767)
+++ tools/test/script_tests/oopsScriptTest.pm	(working copy)
@@ -43,13 +43,292 @@
 my $web = "Sandbox";
 my $topic = "AutoCreatedTopic$$";
 
-sub test_simple {
+sub test_oopsaccesschange {
   my $this = shift;
 
   $this->compareOldAndNew("oops", $web, $topic,
-                          "template=oopsrenameerr&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER");
+                          "template=oopsaccesschange&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
 }
 
-# Should test other parameters
+sub test_oopsaccessgroup {
+  my $this = shift;
 
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsaccessgroup&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsaccessmanage {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsaccessmanage&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsaccessrename {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsaccessrename&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsaccessview {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsaccessview&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsattachnotopic {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsattachnotopic&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsauth {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsauth&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsbadcharset {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsbadcharset&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsbadpwformat {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsbadpwformat&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopschangepasswd {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopschangepasswd&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopscreatenewtopic {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopscreatenewtopic&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsempty {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsempty&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopslocked {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopslocked.pattern&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopslockedrename {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopslockedrename&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsmanage {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsmanage&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsmissing {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsmissing&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsmngcreateweb {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsmngcreateweb&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsmoveerr {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsmoveerr&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsnoformdef {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsnoformdef&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsnotwikiuser {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsnotwikiuser&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsnoweb {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsnoweb&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopspreview {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopspreview&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsregemail {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsregemail&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsregerr {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsregerr&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsregexist {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsregexist&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsregpasswd {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsregpasswd&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsregrequ {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsregrequ&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsregthanks {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsregthanks&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsregwiki {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsregwiki&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsremoveuserdone {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsremoveuserdone&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsrenameerr {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsrenameerr&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsrenamenotwikiword {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsrenamenotwikiword&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsresetpasswd {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsresetpasswd&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsrev {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsrev&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopssaveerr {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopssaveerr&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopssave {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopssave&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopssendmailerr {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopssendmailerr&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopstopicexists {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopstopicexists&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsuploadlimit {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsuploadlimit&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopsupload {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopsupload&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+sub test_oopswrongpassword {
+  my $this = shift;
+
+  $this->compareOldAndNew("oops", $web, $topic,
+                          "template=oopswrongpassword&param1=EINE&param2=ZWEI&param3=DREI&param1=VIER", 1);
+}
+
+
 1;
Index: tools/test/script_tests/ScriptTestFixture.pm
===================================================================
--- tools/test/script_tests/ScriptTestFixture.pm	(revision 1767)
+++ tools/test/script_tests/ScriptTestFixture.pm	(working copy)
@@ -8,7 +8,8 @@
 package ScriptTestFixture;
 
 use base qw(Test::Unit::TestCase);
-use vars qw($urlroot $old $new $olddata $newdata $oldpub $newpub);
+use vars qw($urlroot $old $new $olddata $newdata
+			$oldpub $newpub $user $pass $wget $ab);
 
 BEGIN {
 ##############################################################
@@ -16,12 +17,16 @@
 # Note that for correct operation, the runner has to be able to delete
 # files from the data areas belonging to the two test installations
 $urlroot = "http://localhost";
-$old = "twiki";
-$new = "alphaplus";
+$old = "svn";
+$new = "mine";
 $olddata = "/windows/C/twiki/data";
 $newdata = $olddata;
 $oldpub = "/windows/C/twiki/pub";
 $newpub = $oldpub;
+$user = "TWikiGuest";
+$pass = "";
+$wget = "/usr/bin/wget";
+$ab = "/usr/sbin/ab";
 #############################################################
 
   print STDERR "Sanitising fixtures.....\n";
@@ -46,8 +51,12 @@
     $opts = "";
   }
   #print "WGet $urlroot/$install/bin/$func/$web/$topic$opts\n";
-  my $result = `wget -q -O - $urlroot/$install/bin/$func/$web/$topic$opts`;
+  my $result = `$wget -q -O - $urlroot/$install/bin/$func/$web/$topic$opts`;
   $this->assert(!$?, "WGet $urlroot/$install/bin/$func/$web/$topic$opts failed, $result");
+  if ( $func ne "oops" ) {
+      $this->assert_does_not_match(qr/\(oops\)/, $result, "FAILED RESULT\n$result");
+  }
+
   $result =~ s/\/$install\//\/URL\//g;
   $result =~ s/\?t=[0-9]+\b/?t=0/go;
   $result =~ s/-\s+\d+:\d+\s+-/- DATE -/go;
@@ -68,10 +77,10 @@
 
 # Compare the results of the same URL in old and new
 sub compareOldAndNew {
-  my ($this, $func, $web, $topic, $opts) = @_;
+  my ($this, $func, $web, $topic, $opts, $ignorenl) = @_;
   my $old = $this->getOld($func, $web, $topic, $opts);
   my $new = $this->getNew($func, $web, $topic, $opts);
-  $this->diff($old, $new);
+  $this->diff($old, $new, $ignorenl);
 }
 
 sub oldLocked {
@@ -86,11 +95,13 @@
 
 # Diff two blocks of text
 sub diff {
-  my ($this, $old, $new) = @_;
+  my ($this, $old, $new, $ignorenl) = @_;
   open(WF,">/tmp/old") || die;
+  $old =~ s/\n/ /g if ( $ignorenl );
   print WF $old;
   close(WF) || die;
   open(WF,">/tmp/new") || die;
+  $new =~ s/\n/ /g if ( $ignorenl );
   print WF $new;
   close(WF) || die;
   print STDERR `diff -b -B -w -u /tmp/old /tmp/new`;
Index: tools/test/script_tests/README
===================================================================
--- tools/test/script_tests/README	(revision 1767)
+++ tools/test/script_tests/README	(working copy)
@@ -1,6 +1,9 @@
 Script Tests
 ============
 
+- YOU MUST CONFIGURE THE PATHS IN ScriptTestFixture.pm FOR YOUR CONFIGURATION
+- the command is perl TestRunner.pl CGIScriptSuite.pm
+
 The test suite CGIScriptsSuite.pm is a Test::Unit suite designed to exercise the CGI scripts in TWiki, and is intended primarily to support refactorings. It does this by comparing script results from one server with results from the same script on another, on the assumption that the two servers are standard TWiki installations and both have identical data and pub areas (they can even share the same data and pub if necessary).
 
 The general idea is that you create two CVS checkout areas, keeping one on the latest proven code and the other on bleeding edge code. Running the suite will tell you what you have changed in the system from a user perspective. Ultimately there should be an automatic script that maintains these areas, runs the tests, and mails the results to the core team.
@@ -23,15 +26,3 @@
 rm -rf <path to pub>/Sandbox/AutoCreated*.*
 
 for both old and new installations. Please don't complain at me until you've tried this and re-run the tests.
-
-Test Status
------------
-The following tests are known to FAIL in some respect:
-
-viewfile - fails in old code as well
-save - fails in old code as well
-upload - fails in old code as well
-
-In each case these failures are due to script errors that existed before the refactorings - and therefore the tests - were done. AFAICT they are genuine errors.
-
-It will take time before all the tests pass reliably.
Index: tools/test/script_tests/CGIScriptsSuite.pm
===================================================================
--- tools/test/script_tests/CGIScriptsSuite.pm	(revision 1767)
+++ tools/test/script_tests/CGIScriptsSuite.pm	(working copy)
@@ -7,6 +7,8 @@
 
 sub name { 'CGIScripts' };
 
-sub include_tests { qw(oopsScriptTest viewScriptTest editScriptTest previewScriptTest saveScriptTest renameScriptTest attachScriptTest rdiffScriptTest changesScriptTest statisticsScriptTest viewfileScriptTest uploadScriptTest manageScriptTest ) };
+sub include_tests {
+  qw(oopsScriptTest viewScriptTest editScriptTest previewScriptTest saveScriptTest renameScriptTest attachScriptTest rdiffScriptTest changesScriptTest statisticsScriptTest viewfileScriptTest uploadScriptTest manageScriptTest );
+};
 
 1;
Index: tools/test/script_tests/viewScriptTest.pm
===================================================================
--- tools/test/script_tests/viewScriptTest.pm	(revision 1767)
+++ tools/test/script_tests/viewScriptTest.pm	(working copy)
@@ -43,21 +43,31 @@
 #  $this->SUPER::tear_down();
 #}
 
-sub test_simple {
+sub test_simple1 {
   my $this = shift;
-  $this->compareOldAndNew("view", "TWiki", "TextFormattingRules", undef);
+  $this->compareOldAndNew("view", "TWiki", "WhatIsWikiWiki", undef, 1);
 }
 
-sub test_raw {
+sub test_simple2 {
   my $this = shift;
-  $this->compareOldAndNew("view", "TWiki", "TextFormattingFAQ", "raw=on");
+  $this->compareOldAndNew("view", "TWiki", "TextFormattingRules", undef, 1);
 }
 
-sub test_skinned {
+sub ntest_raw {
   my $this = shift;
-  $this->compareOldAndNew("view", "TWiki", "TextFormattingRules", "skin=print");
+  $this->compareOldAndNew("view", "TWiki", "TextFormattingFAQ", "raw=on", 0);
 }
 
+sub test_print_skinned {
+  my $this = shift;
+  $this->compareOldAndNew("view", "TWiki", "TextFormattingRules", "skin=print", 1);
+}
+
+sub test_dragon_skinned {
+  my $this = shift;
+  $this->compareOldAndNew("view", "TWiki", "TextFormattingRules", "skin=dragon", 1);
+}
+
 # Should test other view parameters
 
 1;
